/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sned;

import java.util.*;

/**
 *
 * @author pepo
 */
public class Test {

	public static void main(String[] args) {

        String[] s1 = {
            "NNP,NNP",
            "CC,NNP",
            "NNP,NNP,CC NNP",
            "IN,NNP,NNP,CC,NNP",
            "NNS,IN,NNP,NNP,CC,NNP",
            "CD,NNS,IN,NNP,NNP,CC,NNP",
            "VBZ,CD,NNS,IN,NNP,NNP,CC,NNP",
            "NNP,VBZ,CD,NNS,IN,NNP,NNP,CC,NNP"
        };

        String[] s2 = {
            "NNP,NNP,CC,NNP",
            "IN,NNP,NNP,CC,NNP",
            "CD,NNS",
            "CD,NNS,IN,NNP,NNP,CC,NNP",
            "VBZ,CD,NNS,IN,NNP,NNP,CC,NNP",
            "NNP,VBZ,CD,NNS,IN,NNP,NNP,CC,NNP",
        };

        long start, end;

        start = System.currentTimeMillis();

        for (int i = 0; i < 1000000; ++i) {
            List<String> s1l = new ArrayList<String>(Arrays.asList(s1));
            List<String> s2l = new ArrayList<String>(Arrays.asList(s2));
            //s1l.retainAll(s2l);

            int j = 0;
            for (String s1s : s1l) {
                for (String s2s : s2l) {
                    if (s1s.equals(s2s)) {
                        ++i;
                    }
            }
            }
            i ^= 123;
        }

        end = System.currentTimeMillis();
        System.out.println("List: "+(end-start)+" ms.");

        start = System.currentTimeMillis();

        for (int i = 0; i < 1000000; ++i) {
            List<String> s1l = Arrays.asList(s1);
            Set<String> s1s = new TreeSet<String>(s1l);
            List<String> s2l = Arrays.asList(s2);
            Set<String> s2s = new TreeSet<String>(s2l);
            s1s.retainAll(s2s);
        }

        end = System.currentTimeMillis();
        System.out.println("Set:  "+(end-start)+" ms.");

        start = System.currentTimeMillis();

        for (int i = 0; i < 1000000; ++i) {
            List<String> s1l = Arrays.asList(s1);
            Set<String> s1s = new TreeSet<String>(s1l);
            List<String> s2l = Arrays.asList(s2);
            Set<String> s2s = new TreeSet<String>(s2l);
            
            int j = 0;
            for (String s : s1s) {
                if (s2s.contains(s)) {
                    ++i;
                }
            }
            i ^= 123;
        }

        end = System.currentTimeMillis();
        System.out.println("Man:  "+(end-start)+" ms.");

    }

}
