package sned;

public class SentenceCost implements Comparable<SentenceCost> {
	public double cost;
	public Sentence sentence;
	public PCFGTree gold;

	public SentenceCost(double c, Sentence s, PCFGTree g){
		this.cost = c;
		this.sentence = s;
		this.gold = g;
	}

	@Override
	public int compareTo(SentenceCost sc) {
		if (this.cost < sc.cost) return -1;
		if (this.cost > sc.cost) return 1;

		if (this.sentence.length() < sc.sentence.length()) return -1;
		if (this.sentence.length() > sc.sentence.length()) return 1;

		return 0;
	}
}
