#! /bin/bash

echo 'Prepare Corpus'

sed 's/")/#/g' penn-wsj-line.txt | awk 'BEGIN{FS="#"}NF<12{print $0}' | sed 's/#/")/g' | tail -n +2 > penn-wsj-line10.txt

#grep -o '\("[^"]\+"\|TOP\)' penn-wsj-line10.txt | sed 's/"//g' | tr '\n' ' ' | sed 's/TOP/\.\n/g' > corpus

#! previous version worked not with the word TOPIC
grep -o '\(([A-Z$\-]\+ "[^"]\+"\|(TOP\)' penn-wsj-line10.txt | tr '\n' ' ' | sed 's/(TOP/\n/g' | sed 's/"//g;s/(//g' | grep -o '[^ ].*' | awk 'BEGIN{ORS=" ";}{print NF/2; for(i=1;i<=NF;i++) print $i; print "\n"}' | grep -o '[^ ].*' > corpus

#TODO | sort | uniq ? 
awk 'NR%10==0{print $0}' penn-wsj-line10.txt > java/data/corpus_test_gold.txt

awk 'NR%10!=0{print $0}' penn-wsj-line10.txt > java/data/corpus_train_gold.txt

awk 'NR%10==0{print $0}' corpus > java/data/corpus_test.txt 

awk 'NR%10!=0{print $0}' corpus > java/data/corpus_train.txt

echo 'Get Cost Function'

./contexts < java/data/corpus_train.txt

head -100 neighs.txt > neighs100.txt

awk 'NR==FNR{a[NR-1]=$2;next;}{print $1 "\t" a[$2] "\t" a[$3]}' spans.txt neighs100.txt | head

mv neighs.txt java/data/neighs.txt
mv spans.txt java/data/spans.txt 

#unit test :P 
wc -l java/data/corpus_train.txt
wc -l java/data/corpus_train_gold.txt
wc -l java/data/corpus_test.txt
wc -l java/data/corpus_test_gold.txt
wc -l corpus

